POJ 1087 A Plug for UNIX / HDU 1526 A Plug for UNIX / ZOJ 1157 A Plug for UNIX / UVA 753 A Plug for UNIX / UVAlive 5418 A Plug for UNIX / SCU 1671 A Plug for UNIX (网络流)

Description

You are in charge of setting up the press room for the inaugural meeting of the United Nations Internet eXecutive (UNIX), which has an international mandate to make the free flow of information and ideas on the Internet as cumbersome and bureaucratic as possible.
Since the room was designed to accommodate reporters and journalists from around the world, it is equipped with electrical receptacles to suit the different shapes of plugs and voltages used by appliances in all of the countries that existed when the room was built. Unfortunately, the room was built many years ago when reporters used very few electric and electronic devices and is equipped with only one receptacle of each type. These days, like everyone else, reporters require many such devices to do their jobs: laptops, cell phones, tape recorders, pagers, coffee pots, microwave ovens, blow dryers, curling
irons, tooth brushes, etc. Naturally, many of these devices can operate on batteries, but since the meeting is likely to be long and tedious, you want to be able to plug in as many as you can.
Before the meeting begins, you gather up all the devices that the reporters would like to use, and attempt to set them up. You notice that some of the devices use plugs for which there is no receptacle. You wonder if these devices are from countries that didn't exist when the room was built. For some receptacles, there are several devices that use the corresponding plug. For other receptacles, there are no devices that use the corresponding plug.
In order to try to solve the problem you visit a nearby parts supply store. The store sells adapters that allow one type of plug to be used in a different type of outlet. Moreover, adapters are allowed to be plugged into other adapters. The store does not have adapters for all possible combinations of plugs and receptacles, but there is essentially an unlimited supply of the ones they do have.

Input

The input will consist of one case. The first line contains a single positive integer n (1 <= n <= 100) indicating the number of receptacles in the room. The next n lines list the receptacle types found in the room. Each receptacle type consists of a string of at most 24 alphanumeric characters. The next line contains a single positive integer m (1 <= m <= 100) indicating the number of devices you would like to plug in. Each of the next m lines lists the name of a device followed by the type of plug it uses (which is identical to the type of receptacle it requires). A device name is a string of at most 24 alphanumeric
characters. No two devices will have exactly the same name. The plug type is separated from the device name by a space. The next line contains a single positive integer k (1 <= k <= 100) indicating the number of different varieties of adapters that are available. Each of the next k lines describes a variety of adapter, giving the type of receptacle provided by the adapter, followed by a space, followed by the type of plug.

Output

A line containing a single non-negative integer indicating the smallest number of devices that cannot be plugged in.

Sample Input

4
A
B
C
D
5
laptop B
phone C
pager B
clock B
comb X
3
B X
X A
X D

Sample Output

1

Http

POJ:https://vjudge.net/problem/POJ-1087
HDU:https://vjudge.net/problem/HDU-1526
ZOJ:https://vjudge.net/problem/ZOJ-1157
UVA:https://vjudge.net/problem/UVA-753
UVAlive:https://vjudge.net/problem/UVALive-5418
SCU:https://vjudge.net/problem/SCU-1671

Source

网络流,最大流

题目大意

现在提供若干规格确定的插座,电器以及插座转换器,其中转换器数量无限。每个插座只能给一个电器插电,转换器可以叠加。现在求不能连接上电的电器数量最小值。

解决思路

这道题想复杂了,之前还想着要把转换器拆成两个点来处理,其实不用。
我们将源点与每一个插座之间连一条流量为1的边(因为一个电器只能供一个,所以可以理解为只提供一个电流)
然后我们对于每一种转换器将对应的插座连上,注意,因为这个时候可能出现转换器转换后出现插座中没出现过的规格。
我们再对每一种电器和它可以匹配的插座或转换器规格连一条容量无穷的边。这里为什么要连无穷大呢?因为在用转换器转换过后可能从别的地方连过来一条边。
最后再在电器与汇点之间连容量为1的边。
需要注意的是,我们要用一个变量n12记下插座数,用n1记下插座数+转换器中新出现的规格数,因为只能在插座与源点之间连线,但可以在任意规格与电器之间连线。
还有一些细节问题,如是否有多组数据,是否有行末换行与组数之间的换行。
虽然笔者是用EK算法实现的最大流,但更推荐的是效率更好的Dinic算法,具体请移步我的这篇文章

代码

#include<iostream>
#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<algorithm>
#include<map>
#include<string>
#include<vector>
#include<queue>
using namespace std;

const int maxN=2000;
const int inf=2147483647;

class Edge
{
public:
    int v,w;
};

int n1,n2,n3;//这三个变量插座,转换器,电器
int n12;//在读入n1后就复制到这里,因为后面可能会改变n1的值
int R1[maxN];//读入插座规格
int R2[maxN];//读入电器规格
int R3[maxN][3];//R3[i][1]代表i号转换器提供的插座规格,R3[i][2]表示i号转换器需要的插座规格
int G[maxN][maxN];
map<string,int> Map;//用于将字符串编号
int Path[maxN];
int Flow[maxN];

bool bfs();

int main()
{
    int T;
    cin>>T;//多组数据,POJ没有,注释掉相关行即可
    for (int ti=1;ti<=T;ti++)
    {
        Map.clear();
        memset(G,0,sizeof(G));
        scanf("%d",&n1);
        for (int i=1;i<=n1;i++)//读入插座规格
        {
            string str;
            cin>>str;
            Map[str]=i;
            R1[i]=i;
        }
        n12=n1;//保存一下,下面要用
        scanf("%d",&n2);
        for (int i=1;i<=n2;i++)//读入电器
        {
            string str;
            cin>>str;//这个名字其实没有用
            cin>>str;
            int k;
            if (Map[str]==0)//遇到之前没有出现的规格要新分配编号。注意这里有可能改变了n1
                k=Map[str]=++n1;
            else
                k=Map[str];
            R2[i]=k;
        }
        scanf("%d",&n3);
        for (int i=1;i<=n3;i++)//读入转换器
        {
            string str;
            cin>>str;
            if (Map[str]==0)//同样遇到之前没有出现过的要新分配编号
                Map[str]=++n1;
            R3[i][1]=Map[str];
            cin>>str;
            if (Map[str]==0)
                Map[str]=++n1;
            R3[i][2]=Map[str];
        }
        //cout<<n1<<' '<<n2<<' '<<n3<<endl;
        for (int i=1;i<=n12;i++)//只能在插座与源点之间连边
            G[0][i]=1;
        for (int i=1;i<=n12;i++)//在插座与对应的电器之间连边
            for (int j=1;j<=n2;j++)
                if (R1[i]==R2[j])
                    G[i][j+n1]=inf;
        for (int i=n12+1;i<=n1;i++)//在新出现的规格与电器之间连边
            for (int j=1;j<=n2;j++)
                if (i==R2[j])
                    G[i][j+n1]=inf;
        for (int i=1;i<=n3;i++)//在转换器对应的插座规格之间连边
            G[R3[i][2]][R3[i][1]]=inf;
        for (int i=1;i<=n2;i++)
            G[i+n1][n1+n2+1]=1;
        //for (int i=0;i<=n1+n2+1;i++)
        //{
        //      for (int j=0;j<=n1+n2+1;j++)
        //      cout<<G[i][j]<<' ';
        //  cout<<endl;
        //  }
        int Ans=0;
        while (bfs())//EK算法求最大流
        {
            int di=Flow[n1+n2+1];
            int now=n1+n2+1;
            int last=Path[now];
            while (now!=0)
            {
                G[last][now]-=di;
                G[now][last]+=di;
                now=last;
                last=Path[now];
            }
            Ans+=di;
        }
        cout<<n2-Ans<<endl;
        if (ti!=T)//注意,如果是多组数据时最后一个不要多输出一个空行
            cout<<endl;
    }
    return 0;
}

bool bfs()//bfs求增广路
{
    memset(Path,-1,sizeof(Path));
    memset(Flow,0,sizeof(Flow));
    queue<int> Q;
    while (!Q.empty())
        Q.pop();
    Q.push(0);
    Flow[0]=inf;
    Path[0]=0;
    do
    {
        int u=Q.front();
        Q.pop();
        for (int i=0;i<=n1+n2+1;i++)
            if ((Path[i]==-1)&&(G[u][i]>0))
            {
                Path[i]=u;
                Flow[i]=min(Flow[u],G[u][i]);
                Q.push(i);
            }
    }
    while (!Q.empty());
    if (Flow[n1+n2+1]==0)
        return 0;
    return 1;
}
内容来源于网络如有侵权请私信删除
你还没有登录,请先登录注册
  • 还没有人评论,欢迎说说您的想法!